#include "stream_related.h"

namespace safe_cuda {
    returnType<std::unique_ptr<CUstream_st, streamDestroyType>> create_stream() noexcept {
        cudaStream_t stream = nullptr;
        const cudaError_t error = cudaStreamCreate(&stream);
        if (error != cudaSuccess) {
            return error;
        }
        return std::unique_ptr<CUstream_st, streamDestroyType>{ stream, cudaStreamDestroy };
    }

}